Subject: Re: Git as a backup system?

From: Dirk Süsserott <[email-masked]>
Date: Mon, 08 Nov 2010 21:06:51 +0100

Am 08.11.2010 19:01 schrieb Eric Frederich:
> I maintain a corporate MediaWiki installation.
> Currently I have a cron job that runs daily and tar's up the contents
> of the installation directory and runs a mysqldump.
>
> I wrote a script that untar'd the contents each backup, gunziped the
> mysql dump, and made a git commit.
> The resulting .git directory wound up being 837M, but after running a
> long (8 minute) "git gc" command, it went down to 204M.
>
> == Questions ==
> What mysqldump options would be good to use for storage in git?
> Right now I'm not passing any parameters to mysqldump and its doing
> all inserts for each table on a single huge line.
> Would git handle it better if each insert was on its own line?
>
> Are any of you using git for a backup system?  Have any tips, words of wisdom?
>
> Thanks,
> ~Eric

Hi Eric,

I also use mysqldump and Git to make backups of my databases. Indeed, it 
performs much better when each change (insert statement) is on a 
separate line. mysqldump has an option for that which I don't recommend, 
because it dramatically slows down the dump and the restore. It would 
then create separate "insert into ..." statement for each changed line.

For me the attached script worked very well: I pipe the output of 
mysqldump through the script and it simply inserts a linefeed after each 
record.

----------------------------------
#!/usr/bin/perl -p

use strict;
use warnings;

# Before:
# INSERT INTO `schliess_grund` VALUES 
(1,'Explizit'),(2,'Neuanmeldung'),(4,'Sperrung'),(3,'Timeout');
#
# After:
# INSERT INTO `schliess_grund` VALUES
#    (1,'Explizit'),
#    (2,'Neuanmeldung'),
#    (4,'Sperrung'),
#    (3,'Timeout');
if (/^(INSERT INTO .*? VALUES) (.*);$/)
{
     $_ = "$1\n     $2\n    ;\n";
     s/\),\(/\)\n    ,\(/g;
}
----------------------------------

The changeset will be much smaller. Let's call the script "wrap.pl". 
Then run the following:

----------------------------------
mysqldump --opt --routines [...] -r <outfile.tmp> <dbname>
./wrap.pl <outfile.tmp> > <outfile>; rm <outfile.tmp>
git add <outfile>
if ! git diff-index --quiet HEAD --; then
     git commit -m "Backup of ..."
fi
----------------------------------

Try it out!

Cheers,
     Dirk